Name: libc
Summary: standard shared libraries for programs
Version: 5.4.25
Release: 1
ExclusiveArch: i386 sparc m68k
ExclusiveOS: Linux
Copyright: distributable
Group: Libraries
Source: sunsite.unc.edu:/pub/Linux/GCC/private/tofu/libc-5.4.25.tar.gz
Patch0: libc-patch
Provides: libc.so.5 libm.so.5 libc.so.5.4.25 libm.so.5.0.8
BuildRoot: /tmp/libc-build

%package devel
Summary: Additional libraries required to compile
Group: Development/Libraries/Libc
Requires: kernel-headers binutils
%package static
Summary: Libraries for static linking
Group: Development/Libraries/Libc
Requires: binutils
%package profile
Summary: libc with profiling support
Group: Development/Libraries/Libc
Requires: binutils
%package debug
Summary: libc with debugging information
Group: Development/Libraries/Libc
Requires: binutils

%description
Contains the standard libraries that are used by multiple programs on
the system. In order to save disk space and memory, as well as to 
ease upgrades, common system code is kept in one place and shared between
programs. This package contains the most important sets of shared libraries,
the standard C library and the standard math library. Without these, a 
Linux system will not function.

%description devel
To develop programs which use the standard C libraries (which nearly all
programs do), the system needs to have these standard header files and object
files available for creating the executables.

%description static
While most programs are distributed dynamically linked, and therefore need
access to the standard shared libraries, some developers prefer to
ship programs statically linked, which includes all of the standard library
code in the executable. While this results in significantly larger 
programs and increases their memory usage, it does increase the portability
of programs between Linux systems.

%description profile
When programs are being profiled used gprof, they must use these libraries
instrad of the standard C libraries for gprof to be able to profile
them correctly.

%description debug
These libraries have the debugging information debuggers use for tracing
the execution of programs. These are only needed when the shared libraries
themselves are being debugged -- they are not needed to debug programs which
use them. 

%package -n locale
Summary: Tools for manipulation locale definition files for other languages
Group: Utilities/Text
%description -n locale
This package includes the tools necessary to generate and manipulate the
locale definition files that libc uses to provide multi-lingual support.

%prep
%setup -c

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

mkdir $RPM_BUILD_ROOT/etc
mkdir $RPM_BUILD_ROOT/usr
mkdir $RPM_BUILD_ROOT/usr/bin
mkdir $RPM_BUILD_ROOT/usr/include

cd include
# Assumes that the kernel sources are in their standard places...
ln -s /usr/src/linux/include/linux .
ln -s /usr/src/linux/include/asm .

cd ../libc

%patch0 -p1

./configure <<EOF

%build

cd libc

mv config.in config.in.tmpl
sed "s&\\(TARGET_ROOTDIR=\\).\\\*&\\1$RPM_BUILD_ROOT&" < config.in.tmpl > config.in

make
make -C locale locale localedef

%install
rm -rf $RPM_BUILD_ROOT
# Needed for the locale progs...
mkdir -p $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/etc

tar cvSpf - include | (cd $RPM_BUILD_ROOT/usr; tar xSpf -)

# this comes from the linuxthreads package
rm -f $RPM_BUILD_ROOT/usr/include/pthread.h

install -m755 -s libc/locale/locale $RPM_BUILD_ROOT/usr/bin/locale
install -m755 -s libc/locale/localedef $RPM_BUILD_ROOT/usr/bin/localedef

cd libc
make RPM_BUILD_ROOT="$RPM_BUILD_ROOT" install

rm -f $RPM_BUILD_ROOT/usr/include/linux $RPM_BUILD_ROOT/usr/include/asm
ln -sf ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux
ln -sf ../src/linux/include/asm $RPM_BUILD_ROOT/usr/include/asm

install -m644 nys/nsw/etc/nsswitch.conf $RPM_BUILD_ROOT/etc

mkdir -p $RPM_BUILD_ROOT/usr/lib
cd $RPM_BUILD_ROOT/usr/lib
rm -f libc.so libm.so
ln -s ../../lib/libc.so.5.4.25 libc.so
ln -s ../../lib/libm.so.5.0.8 libm.so
rm -f $RPM_BUILD_ROOT/usr/include/ansidecl.h
rm -f $RPM_BUILD_ROOT/usr/include/obstack.h

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%doc libc/README.nys libc/nys/README libc/nys/nis/etc/nis.conf libc/nys/yp/etc/yp.conf
%config /etc/nsswitch.conf
/lib/libm.so.5.0.8
/lib/libc.so.5.4.25

%files devel
/usr/lib/crt1.o
/usr/lib/crtbegin.o
/usr/lib/crtbeginS.o
/usr/lib/crtend.o
/usr/lib/crtendS.o
/usr/lib/crti.o
/usr/lib/crtn.o
/usr/lib/gcrt1.o
/usr/lib/libbsd.a
/usr/lib/libgmon.a
/usr/lib/libmcheck.a
/usr/lib/libc.so
/usr/lib/libm.so
/usr/include/


%files static
/usr/lib/libc.a
/usr/lib/libm.a

%files profile
/usr/lib/libc_p.a

%files debug
/usr/lib/libg.a

%files -n locale
/usr/bin/locale
/usr/bin/localedef
